/*
Copyright (c) 2016, d.v.postarnak (d.v.postarnak@utmn.ru)
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include <stdio.h>
#include <stdlib.h>
#include "mysql.h"

#define IH_MYSQL_HOST "localhost"
#define IH_MYSQL_LOGIN "root"
#define IH_MYSQL_PASSWORD "pass"
#define IH_MYSQL_DBNAME "irbis_history"


#ifdef DEBUG
FILE *ff;
#endif

class CIrbis_record_parser{
public:
	
	CIrbis_record_parser(char *szIrbis_record){
		this->szIrbis_record = szIrbis_record;
		ui16Current_line = 0;
		BInterrupt_search = false;
#ifdef DEBUG
		fprintf(ff,"!current_line 0!\n");
		fprintf(ff,"!BInterrupt_search false!\n");
		fprintf(ff,"___________________________\n");
#endif
	}
	
	virtual ~CIrbis_record_parser(){
	}

	
	void restart_proc(){
		ui16Current_line = 0;
		BInterrupt_search = false;
#ifdef DEBUG
		fprintf(ff,"!current_line 0!\n");
		fprintf(ff,"!BInterrupt_search false!\n");
		fprintf(ff,"___________________________\n");
#endif
	}
	void main_proc(){
		
		static const unsigned short cui16Cur_field_size = 49152;
		char szCur_field[cui16Cur_field_size];
		szCur_field[0]=0;
		
		
		strcat(szIrbis_record,"\n");
		
		for (unsigned int ui32 = 0;ui32 < strlen(szIrbis_record);ui32++){
			if (szIrbis_record[ui32] == 13)
				continue;
			if (szIrbis_record[ui32] == 10){
			
				if (strlen(szCur_field) != 0){
					next_field(szCur_field);
					if (BInterrupt_search){
#ifdef DEBUG
						fprintf(ff,"!obriv poiska vizvan!\n");
						fprintf(ff,"___________________________\n");
#endif
						break;
					}
					ui16Current_line++;
				}
				szCur_field[0]=0;
				
				continue;
			}
			strncat(szCur_field,&szIrbis_record[ui32],1);
		}
		
		szIrbis_record[strlen(szIrbis_record)-strlen("\n")]=0;
#ifdef DEBUG
		fprintf(ff,"!konec!\n\n\n\n\n\n");
		fprintf(ff,"___________________________\n");
#endif
		
	}
protected:
	unsigned short ui16Current_line;
	bool BInterrupt_search;
private:
	virtual void next_field(char *szField) = 0;
	
	char *szIrbis_record;

};




class CIrbis_record_finder : public CIrbis_record_parser {
public:

	CIrbis_record_finder(char *szIrbis_record) : CIrbis_record_parser(szIrbis_record) {
		
		
		
	} 

	void finder_restart_proc(const char *szField){
		
		snprintf(this->szFind_field, 49152, "%s", szField);
		
		restart_proc();
		BFound = false;
#ifdef DEBUG
		fprintf(ff,"!BFound false!\n");
		fprintf(ff,"___________________________\n");
#endif
	}
	
	bool BFound;
protected:
	
	char szFind_field[49152];
	
	
	
private:	
	
	virtual void field_found() = 0;


	void next_field(char *szField){
		
		if ( !strcmp(szFind_field,szField) ){
			BFound = true;
#ifdef DEBUG
			fprintf(ff,"!szFind_field = szField!\n");
			fprintf(ff,"!BFound true!\n");
			fprintf(ff,"___________________________\n");
#endif
			field_found();
		}
	}
	
};

class CMake_new_alien_record : public CIrbis_record_finder {
public:

	CMake_new_alien_record(char *szIrbis_record, char *szIrbis_output_record ) : CIrbis_record_finder(szIrbis_record) {
		this->szIrbis_output_record = szIrbis_output_record;
		
		for (unsigned short ui16 = 0; ui16 < cui16Line_compared_size; ui16++){
			abLine_compared[ui16] = false;
		}
#ifdef DEBUG
		fprintf(ff,"!all abLine_compared elements false!\n");
		fprintf(ff,"___________________________\n");
#endif
		
	}
	
	
	void alien_restart_proc(const char *szField){
		
		finder_restart_proc(szField);
	}
	
	
private:
	char *szIrbis_output_record;
	
	static const unsigned short cui16Line_compared_size = 49152;
	bool abLine_compared[ cui16Line_compared_size ];
	
	
	void field_found(){
#ifdef DEBUG
		fprintf(ff,"==============================\n");
		fprintf(ff,"!obrabotka naidennoy stroki. stroka nomer %d!\n",ui16Current_line);
#endif
		
		if (!abLine_compared[ui16Current_line]){
			abLine_compared[ui16Current_line] = true;
#ifdef DEBUG
			fprintf(ff,"!stroka nomer %d imeet pravo na sravnenie!\n",ui16Current_line);
#endif
			
			if (szIrbis_output_record != NULL){
#ifdef DEBUG
				fprintf(ff,"!stroka nomer %d vivedena v raznitsu!\n",ui16Current_line);
#endif
				
				strcat(this->szIrbis_output_record,"\n");
				strcat(this->szIrbis_output_record,szFind_field);
			}
			
			BInterrupt_search = true;
#ifdef DEBUG
			fprintf(ff,"!vizivaem obriv poiska!\n",ui16Current_line);
			fprintf(ff,"==============================\n");
#endif
		}
	}
};















class CIrbis_record_walker : public CIrbis_record_parser {
public:
	CIrbis_record_walker(char *szIrbis_record, char *szIrbis_accessed_record, char *szIrbis_1output_record, char *szIrbis_2output_record) : CIrbis_record_parser(szIrbis_record) {

		this->szIrbis_2output_record = szIrbis_2output_record;
		
		OMake_new_alien_record = new CMake_new_alien_record(szIrbis_accessed_record, szIrbis_1output_record);
	}
	~CIrbis_record_walker(){
		delete OMake_new_alien_record;
		
	}
	
private:
	
	char *szIrbis_2output_record;
	CMake_new_alien_record *OMake_new_alien_record;

	void next_field(char *szField){
	
		OMake_new_alien_record->alien_restart_proc(szField);
		OMake_new_alien_record->main_proc();
		
		if (szIrbis_2output_record != NULL){
			if (!OMake_new_alien_record->BFound){
				
				strcat(this->szIrbis_2output_record,"\n");
				strcat(this->szIrbis_2output_record, szField);
				
			}
		}
		
		
		
		
	}
	
};








MYSQL mysql;
MYSQL_RES *res;
MYSQL_ROW row;




extern "C" {
	
__declspec(dllexport) int save_history_rdr(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_ibis(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_cmpl(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_bibl(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_ebs(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_hist(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_marc(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_mars(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_pr(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_retrow(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_statros(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_vkr(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_vuz(char *buf1, char *buf2, int bufsize);
__declspec(dllexport) int save_history_wtr(char *buf1, char *buf2, int bufsize);

}









int save_history(char *buf1, char *buf2, int bufsize, char *szDB_name){

#ifdef DEBUG
FILE *f=fopen("datahist.txt","wb");
ff=fopen("datahist2.txt","wb");
#endif


//экранируем все апострофы во входном массиве
#ifdef DEBUG
	fprintf(f,"!%s!\n",buf1);
	fprintf(f,"___________________________\n");
#endif
	
	const unsigned short cui16Buf1_processed_str_size = 49152;
	char szBuf1_processed_str[cui16Buf1_processed_str_size];
	szBuf1_processed_str[0]=0;
	for (unsigned short ui16=0; ui16 < bufsize; ui16++){
		if (buf1[ui16] == 0)
			break;
		if (buf1[ui16] == 39){
			strcat(szBuf1_processed_str,"\\'");
		} else {
			strncat(szBuf1_processed_str,&buf1[ui16],1);
		}
	}

//заменяем все 13 на 10
	for (unsigned short ui16=0; ui16 < strlen(szBuf1_processed_str); ui16++){
		if (szBuf1_processed_str[ui16]==13)
			szBuf1_processed_str[ui16]=10;
	}
#ifdef DEBUG
	fprintf(f,"!%s!\n",szBuf1_processed_str);
	fprintf(f,"___________________________\n");
#endif
	char szIrbis_initial_record[49152];
	szIrbis_initial_record[0] = 0;
	
	char szIrbis_changed_record[49152];
	szIrbis_changed_record[0] = 0;
	
	
//теперь достаём из входного массива логин
	char szLogin[1024];
	szLogin[0]=0;
	unsigned short ui16Cur_pos = 0;
	
	
	
	for (unsigned short ui16=0; ui16 < cui16Buf1_processed_str_size; ui16++){
		
		if ( szBuf1_processed_str[ui16] == 10 ){
			ui16Cur_pos = ui16+1;
			break;
		}
		
		strncat(szLogin,&szBuf1_processed_str[ui16],1);
		
	}
#ifdef DEBUG
	fprintf(f,"!%s!\n",szLogin);
	fprintf(f,"___________________________\n");
#endif

	char i8Set_cnt = 1;

	//теперь достаём из входного массива мфн
	char szMfn[1024];
	szMfn[0]=0;
	
	for (unsigned short ui16=ui16Cur_pos; ui16 < cui16Buf1_processed_str_size; ui16++){
		
		if ( szBuf1_processed_str[ui16] == 10 ){
			ui16Cur_pos = ui16+1;
			break;
		}
		
		strncat(szMfn,&szBuf1_processed_str[ui16],1);
		
	}
#ifdef DEBUG
	fprintf(f,"!%s!\n",szMfn);
	fprintf(f,"___________________________\n");
#endif
	bool bMade_set = false;

//теперь разделяем входной массив данных на две записи
/*
одна запись отделяется от другой символом ^ в начале строки.
в нормальных условиях такого не бывает.
*/
	
	char bWrap_was = 0;
	char bSecond_rec = 0;
	for (unsigned short ui16=ui16Cur_pos; ui16 < cui16Buf1_processed_str_size; ui16++){
		
		
		
		
		if (szBuf1_processed_str[ui16] == 0){
			bWrap_was = 0;
			break;
		
		} else if (szBuf1_processed_str[ui16] == 10){
			bWrap_was = 1;
			
			i8Set_cnt++;
			if (i8Set_cnt == 2){
				i8Set_cnt = 1;
				bMade_set = true;
			}
			
		} else if (szBuf1_processed_str[ui16] == '^'){
			if (bWrap_was){
				bSecond_rec = 1;
				bWrap_was = 0;
				continue;
			}
			
			bWrap_was = 0;
		} else {
			bWrap_was = 0;
		}
		
		
		
		if (bSecond_rec){
			strncat(szIrbis_changed_record,&szBuf1_processed_str[ui16],1);
		} else {
			strncat(szIrbis_initial_record,&szBuf1_processed_str[ui16],1);
		}
	
		
		
		
	}
#ifdef DEBUG
	fprintf(f,"!%s!\n",szIrbis_initial_record);
	fprintf(f,"___________________________\n");
	fprintf(f,"!%s!\n",szIrbis_changed_record);
	fprintf(f,"___________________________\n");
#endif
	if (bMade_set){
		i8Set_cnt = 0;
	}
//теперь осталось отсчитать три переноса в каждой записи и исключить содержимое до них
	int i32Cur_wraps_cnt = 0;
	unsigned short ui16Cur_pos_initial = 0;
	
	
	for (unsigned short ui16=0; ui16 < 49152; ui16++){
		if ( szIrbis_initial_record[ui16] == 10 ){
			i32Cur_wraps_cnt++;
			if (i32Cur_wraps_cnt == 3){
				ui16Cur_pos_initial = ui16+1;
				break;
			}
		}
		
	}
	
	i32Cur_wraps_cnt = 0;
	unsigned short ui16Cur_pos_changed = 0;
	
	
	for (unsigned short ui16=0; ui16 < 49152; ui16++){
		if ( szIrbis_changed_record[ui16] == 10 ){
			i32Cur_wraps_cnt++;
			if (i32Cur_wraps_cnt == 3){
				ui16Cur_pos_changed = ui16+1;
				break;
			}
		}
		
	}
	
	
#ifdef DEBUG
	fprintf(f,"!FIRST_ARG!!%s!!!\n", &szIrbis_initial_record[ui16Cur_pos_initial] );
	fprintf(f,"___________________________\n");
#endif
	
	
	
	


	//теперь записываем в базу обе этих записи



	

	
	mysql_init(&mysql);
	
	mysql_options(&mysql, MYSQL_SET_CHARSET_NAME, "utf8");
	mysql_options(&mysql, MYSQL_INIT_COMMAND, "SET NAMES utf8");





	if (!(mysql_real_connect(&mysql,IH_MYSQL_HOST,IH_MYSQL_LOGIN,IH_MYSQL_PASSWORD,IH_MYSQL_DBNAME,0,NULL,0) )  ){
		snprintf(buf2,bufsize,"1 %s\n", mysql_error(&mysql));
		return 1;
	}





	const unsigned short cui16Query_str_size = 49152;
	char szQuery_str[cui16Query_str_size];

	snprintf(szQuery_str,cui16Query_str_size,"select changed_rec from %s where mfn = %s and whenwas >= all(select whenwas from %s where mfn = %s)",szDB_name, szMfn, szDB_name, szMfn);

	if (mysql_query(&mysql,szQuery_str) ){
		snprintf(buf2,bufsize,"2 %s\n", mysql_error(&mysql));
		return 1;
	}
	if (!(res = mysql_store_result(&mysql))) {
		snprintf(buf2,bufsize,"3 %s\n", mysql_error(&mysql));
		return 1;
	}

	
	const unsigned short cui16Irbis_previous_changed_record_size = 49152;
	char szIrbis_previous_changed_record[cui16Irbis_previous_changed_record_size];
	szIrbis_previous_changed_record[0] = 0;
	
	while((row = mysql_fetch_row(res))) {
		snprintf( szIrbis_previous_changed_record, cui16Irbis_previous_changed_record_size, "%s", row[0] );
		
	}
	
#ifdef DEBUG
	fprintf(f,"!SECOND_ARG!!%s!!!\n", szIrbis_previous_changed_record  );
	fprintf(f,"___________________________\n");
#endif
	
	char szIrbis_2output_record[49152];
	szIrbis_2output_record[0]=0;
	
	
	
	if (strlen(szIrbis_previous_changed_record) > 0 ){
		CIrbis_record_walker *OIrbis_record_walker = new CIrbis_record_walker( &szIrbis_initial_record[ui16Cur_pos_initial], szIrbis_previous_changed_record, NULL, szIrbis_2output_record);
		
		OIrbis_record_walker->main_proc();
		
		delete OIrbis_record_walker;
	}
#ifdef DEBUG
	fprintf(f,"!!!%s!!!\n",szIrbis_2output_record);
	fprintf(f,"___________________________\n");
#endif
	
	
	
	
	if (strlen(szLogin) > 0){
		snprintf(szQuery_str,cui16Query_str_size,"INSERT INTO %s (initial_rec, changed_rec, alien_uncontrolled_text, alien_controlled_text,               mfn, login, whenwas) VALUES('%s','%s','%s','',%s,'%s',NOW() )", szDB_name, &szIrbis_initial_record[ui16Cur_pos_initial], &szIrbis_changed_record[ui16Cur_pos_changed], szIrbis_2output_record, szMfn,szLogin);
	} else {
		snprintf(szQuery_str,cui16Query_str_size,"INSERT INTO %s (initial_rec, changed_rec, alien_uncontrolled_text, alien_controlled_text,               mfn, whenwas) VALUES('%s','','%s','%s',%s,NOW() )", szDB_name, &szIrbis_initial_record[ui16Cur_pos_initial], szIrbis_2output_record, &szIrbis_changed_record[ui16Cur_pos_changed], szMfn);
	}
#ifdef DEBUG
	fprintf(f,"!%s!\n",szQuery_str);
#endif
	
	if (mysql_query(&mysql,szQuery_str) ){
		snprintf(buf2,bufsize,"2 %s\n", mysql_error(&mysql));
		return 1;
	}
	
	
	
	
	mysql_free_result(res);
	
	mysql_close(&mysql);
	
	
	snprintf(buf2,bufsize,"0");
	
#ifdef DEBUG
	fclose(f);
	
	fclose(ff);
#endif
	return 0;

}

__declspec(dllexport) int save_history_rdr(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"rdr");
}
__declspec(dllexport) int save_history_ibis(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"ibis");
}
__declspec(dllexport) int save_history_cmpl(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"cmpl");
}
__declspec(dllexport) int save_history_bibl(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"bibl");
}
__declspec(dllexport) int save_history_ebs(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"ebs");
}
__declspec(dllexport) int save_history_hist(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"hist");
}
__declspec(dllexport) int save_history_marc(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"marc");
}
__declspec(dllexport) int save_history_mars(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"mars");
}
__declspec(dllexport) int save_history_pr(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"pr");
}
__declspec(dllexport) int save_history_retrow(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"retrow");
}
__declspec(dllexport) int save_history_statros(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"statros");
}
__declspec(dllexport) int save_history_vkr(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"vkr");
}
__declspec(dllexport) int save_history_vuz(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"vuz");
}
__declspec(dllexport) int save_history_wtr(char *buf1, char *buf2, int bufsize){
	return save_history(buf1, buf2, bufsize,"wtr");
}

